diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/graymorph.c leptonlib-1.066/src/graymorph.c
--- leptonlib-1.66/src/graymorph.c	2007-06-09 08:43:52.000000000 +0300
+++ leptonlib-1.066/src/graymorph.c	2010-09-15 15:19:17.000000000 +0300
@@ -17,26 +17,42 @@
 /*
  *  graymorph.c
  *
- *      Top-level binary morphological operations
- *
+ *      Top-level binary morphological operations (van Herk / Gil-Werman)
  *            PIX     *pixErodeGray()
  *            PIX     *pixDilateGray()
  *            PIX     *pixOpenGray()
  *            PIX     *pixCloseGray()
  *
+ *      Special operations for 1x3, 3x1 and 3x3 Sels  (direct)
+ *            PIX     *pixErodeGray3()
+ *            PIX     *pixDilateGray3()
+ *            PIX     *pixOpenGray3()
+ *            PIX     *pixCloseGray3()
+ *
  *
  *      Method: Algorithm by van Herk and Gil and Werman, 1992
  *
- *      Measured speed is about 1 output pixel per 120 PIII clock cycles,
- *      for a horizontal or vertical erosion or dilation.  The 
- *      computation time doubles for opening or closing, or for a
- *      square SE, as expected, and is independent of the size of the SE.
+ *      Measured speed of the vH/G-W implementation is about 1 output
+ *      pixel per 120 PIII clock cycles, for a horizontal or vertical
+ *      erosion or dilation.  The computation time doubles for opening
+ *      or closing, or for a square SE, as expected, and is independent
+ *      of the size of the SE.
+ *
+ *      A faster implementation can be made directly for brick Sels
+ *      of maximum size 3.  We unroll the computation for sets of 8 bytes.
+ *      It needs to be called explicitly; the general functions do not
+ *      default for the size 3 brick Sels.
  */
 
 #include <stdio.h>
 #include <stdlib.h>
 #include "allheaders.h"
 
+static PIX *pixErodeGray3h(PIX *pixs);
+static PIX *pixErodeGray3v(PIX *pixs);
+static PIX *pixDilateGray3h(PIX *pixs);
+static PIX *pixDilateGray3v(PIX *pixs);
+
 
 /*-----------------------------------------------------------------*
  *              Top-level gray morphological operations            *
@@ -109,8 +125,7 @@
     if ((pixt = pixCreateTemplate(pixb)) == NULL)
         return (PIX *)ERROR_PTR("pixt not made", procName, NULL);
     
-    w = pixGetWidth(pixt);
-    h = pixGetHeight(pixt);
+    pixGetDimensions(pixt, &w, &h, NULL);
     datab = pixGetData(pixb);
     datat = pixGetData(pixt);
     wplb = pixGetWpl(pixb);
@@ -219,8 +234,7 @@
     if ((pixt = pixCreateTemplate(pixb)) == NULL)
         return (PIX *)ERROR_PTR("pixt not made", procName, NULL);
     
-    w = pixGetWidth(pixt);
-    h = pixGetHeight(pixt);
+    pixGetDimensions(pixt, &w, &h, NULL);
     datab = pixGetData(pixb);
     datat = pixGetData(pixt);
     wplb = pixGetWpl(pixb);
@@ -330,8 +344,7 @@
     if ((pixt = pixCreateTemplate(pixb)) == NULL)
         return (PIX *)ERROR_PTR("pixt not made", procName, NULL);
     
-    w = pixGetWidth(pixt);
-    h = pixGetHeight(pixt);
+    pixGetDimensions(pixt, &w, &h, NULL);
     datab = pixGetData(pixb);
     datat = pixGetData(pixt);
     wplb = pixGetWpl(pixb);
@@ -457,8 +470,7 @@
     if ((pixt = pixCreateTemplate(pixb)) == NULL)
         return (PIX *)ERROR_PTR("pixt not made", procName, NULL);
     
-    w = pixGetWidth(pixt);
-    h = pixGetHeight(pixt);
+    pixGetDimensions(pixt, &w, &h, NULL);
     datab = pixGetData(pixb);
     datat = pixGetData(pixt);
     wplb = pixGetWpl(pixb);
@@ -514,4 +526,505 @@
     return pixd;
 }
 
+
+/*-----------------------------------------------------------------*
+ *           Special operations for 1x3, 3x1 and 3x3 Sels          *
+ *-----------------------------------------------------------------*/
+/*!
+ *  pixErodeGray3()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *              hsize  (1 or 3)
+ *              vsize  (1 or 3)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for 1x3, 3x1 or 3x3 brick sel (all hits)
+ *      (2) If hsize = vsize = 1, just returns a copy.
+ *      (3) It would be nice not to add a border, but it is required
+ *          if we want the same results as from the general case.
+ *          We add 4 bytes on the left to speed up the copying, and
+ *          8 bytes at the right and bottom to allow unrolling of
+ *          the computation of 8 pixels.
+ */
+PIX *
+pixErodeGray3(PIX     *pixs,
+              l_int32  hsize,
+              l_int32  vsize)
+{
+PIX  *pixt, *pixb, *pixbd, *pixd;
+
+    PROCNAME("pixErodeGray3");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pix has colormap", procName, NULL);
+    if ((hsize != 1 && hsize != 3) ||
+        (vsize != 1 && vsize != 3))
+        return (PIX *)ERROR_PTR("invalid size: must be 1 or 3", procName, NULL);
+
+    if (hsize == 1 && vsize == 1)
+        return pixCopy(NULL, pixs);
+
+    pixb = pixAddBorderGeneral(pixs, 4, 8, 2, 8, 255);
+
+    if (vsize == 1)
+        pixbd = pixErodeGray3h(pixb);
+    else if (hsize == 1)
+        pixbd = pixErodeGray3v(pixb);
+    else {  /* vize == hsize == 3 */
+        pixt = pixErodeGray3h(pixb);
+        pixbd = pixErodeGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+
+    pixd = pixRemoveBorderGeneral(pixbd, 4, 8, 2, 8);
+    pixDestroy(&pixb);
+    pixDestroy(&pixbd);
+    return pixd;
+}
+
+
+/*!
+ *  pixErodeGray3h()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for horizontal 3x1 brick Sel;
+ *          also used as the first step for the 3x3 brick Sel.
+ */
+static PIX *
+pixErodeGray3h(PIX  *pixs)
+{
+l_uint32  *datas, *datad, *lines, *lined;
+l_int32    w, h, wpl, i, j;
+l_int32    val0, val1, val2, val3, val4, val5, val6, val7, val8, val9, minval;
+PIX       *pixd;
+
+    PROCNAME("pixErodeGray3h");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+
+    pixd = pixCreateTemplateNoInit(pixs);
+    pixSetBorderVal(pixd, 4, 8, 2, 8, 0);  /* only to silence valgrind */
+    pixGetDimensions(pixs, &w, &h, NULL);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    for (i = 0; i < h; i++) {
+        lines = datas + i * wpl;
+        lined = datad + i * wpl;
+        for (j = 1; j < w - 8; j += 8) {
+            val0 = GET_DATA_BYTE(lines, j - 1);
+            val1 = GET_DATA_BYTE(lines, j);
+            val2 = GET_DATA_BYTE(lines, j + 1);
+            val3 = GET_DATA_BYTE(lines, j + 2);
+            val4 = GET_DATA_BYTE(lines, j + 3);
+            val5 = GET_DATA_BYTE(lines, j + 4);
+            val6 = GET_DATA_BYTE(lines, j + 5);
+            val7 = GET_DATA_BYTE(lines, j + 6);
+            val8 = GET_DATA_BYTE(lines, j + 7);
+            val9 = GET_DATA_BYTE(lines, j + 8);
+            minval = L_MIN(val1, val2);
+            SET_DATA_BYTE(lined, j, L_MIN(val0, minval));
+            SET_DATA_BYTE(lined, j + 1, L_MIN(minval, val3));
+            minval = L_MIN(val3, val4);
+            SET_DATA_BYTE(lined, j + 2, L_MIN(val2, minval));
+            SET_DATA_BYTE(lined, j + 3, L_MIN(minval, val5));
+            minval = L_MIN(val5, val6);
+            SET_DATA_BYTE(lined, j + 4, L_MIN(val4, minval));
+            SET_DATA_BYTE(lined, j + 5, L_MIN(minval, val7));
+            minval = L_MIN(val7, val8);
+            SET_DATA_BYTE(lined, j + 6, L_MIN(val6, minval));
+            SET_DATA_BYTE(lined, j + 7, L_MIN(minval, val9));
+        }
+    }
+    return pixd;
+}
+
+
+/*!
+ *  pixErodeGray3v()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for vertical 1x3 brick Sel;
+ *          also used as the second step for the 3x3 brick Sel.
+ *      (2) Surprisingly, this is faster than setting up the
+ *          lineptrs array and accessing into it; e.g.,
+ *              val4 = GET_DATA_BYTE(lines8[i + 3], j);
+ */
+static PIX *
+pixErodeGray3v(PIX  *pixs)
+{
+l_uint32  *datas, *datad, *linesi, *linedi;
+l_int32    w, h, wpl, i, j;
+l_int32    val0, val1, val2, val3, val4, val5, val6, val7, val8, val9, minval;
+PIX       *pixd;
+
+    PROCNAME("pixErodeGray3v");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+
+    pixd = pixCreateTemplateNoInit(pixs);
+    pixGetDimensions(pixs, &w, &h, NULL);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    for (j = 0; j < w; j++) {
+        for (i = 1; i < h - 8; i += 8) {
+            linesi = datas + i * wpl;
+            linedi = datad + i * wpl;
+            val0 = GET_DATA_BYTE(linesi - wpl, j);
+            val1 = GET_DATA_BYTE(linesi, j);
+            val2 = GET_DATA_BYTE(linesi + wpl, j);
+            val3 = GET_DATA_BYTE(linesi + 2 * wpl, j);
+            val4 = GET_DATA_BYTE(linesi + 3 * wpl, j);
+            val5 = GET_DATA_BYTE(linesi + 4 * wpl, j);
+            val6 = GET_DATA_BYTE(linesi + 5 * wpl, j);
+            val7 = GET_DATA_BYTE(linesi + 6 * wpl, j);
+            val8 = GET_DATA_BYTE(linesi + 7 * wpl, j);
+            val9 = GET_DATA_BYTE(linesi + 8 * wpl, j);
+            minval = L_MIN(val1, val2);
+            SET_DATA_BYTE(linedi, j, L_MIN(val0, minval));
+            SET_DATA_BYTE(linedi + wpl, j, L_MIN(minval, val3));
+            minval = L_MIN(val3, val4);
+            SET_DATA_BYTE(linedi + 2 * wpl, j, L_MIN(val2, minval));
+            SET_DATA_BYTE(linedi + 3 * wpl, j, L_MIN(minval, val5));
+            minval = L_MIN(val5, val6);
+            SET_DATA_BYTE(linedi + 4 * wpl, j, L_MIN(val4, minval));
+            SET_DATA_BYTE(linedi + 5 * wpl, j, L_MIN(minval, val7));
+            minval = L_MIN(val7, val8);
+            SET_DATA_BYTE(linedi + 6 * wpl, j, L_MIN(val6, minval));
+            SET_DATA_BYTE(linedi + 7 * wpl, j, L_MIN(minval, val9));
+        }
+    }
+    return pixd;
+}
+
+
+/*!
+ *  pixDilateGray3()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *              hsize  (1 or 3)
+ *              vsize  (1 or 3)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for 1x3, 3x1 or 3x3 brick sel (all hits)
+ *      (2) If hsize = vsize = 1, just returns a copy.
+ */
+PIX *
+pixDilateGray3(PIX     *pixs,
+               l_int32  hsize,
+               l_int32  vsize)
+{
+PIX  *pixt, *pixb, *pixbd, *pixd;
+
+    PROCNAME("pixDilateGray3");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pix has colormap", procName, NULL);
+    if ((hsize != 1 && hsize != 3) ||
+        (vsize != 1 && vsize != 3))
+        return (PIX *)ERROR_PTR("invalid size: must be 1 or 3", procName, NULL);
+
+    if (hsize == 1 && vsize == 1)
+        return pixCopy(NULL, pixs);
+
+    pixb = pixAddBorderGeneral(pixs, 4, 8, 2, 8, 0);
+
+    if (vsize == 1)
+        pixbd = pixDilateGray3h(pixb);
+    else if (hsize == 1)
+        pixbd = pixDilateGray3v(pixb);
+    else {  /* vize == hsize == 3 */
+        pixt = pixDilateGray3h(pixb);
+        pixbd = pixDilateGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+
+    pixd = pixRemoveBorderGeneral(pixbd, 4, 8, 2, 8);
+    pixDestroy(&pixb);
+    pixDestroy(&pixbd);
+    return pixd;
+}
+
+
+/*!
+ *  pixDilateGray3h()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for horizontal 3x1 brick Sel;
+ *          also used as the first step for the 3x3 brick Sel.
+ */
+static PIX *
+pixDilateGray3h(PIX  *pixs)
+{
+l_uint32  *datas, *datad, *lines, *lined;
+l_int32    w, h, wpl, i, j;
+l_int32    val0, val1, val2, val3, val4, val5, val6, val7, val8, val9, maxval;
+PIX       *pixd;
+
+    PROCNAME("pixDilateGray3h");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+
+    pixd = pixCreateTemplateNoInit(pixs);
+    pixSetBorderVal(pixd, 4, 8, 2, 8, 0);  /* only to silence valgrind */
+    pixGetDimensions(pixs, &w, &h, NULL);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    for (i = 0; i < h; i++) {
+        lines = datas + i * wpl;
+        lined = datad + i * wpl;
+        for (j = 1; j < w - 8; j += 8) {
+            val0 = GET_DATA_BYTE(lines, j - 1);
+            val1 = GET_DATA_BYTE(lines, j);
+            val2 = GET_DATA_BYTE(lines, j + 1);
+            val3 = GET_DATA_BYTE(lines, j + 2);
+            val4 = GET_DATA_BYTE(lines, j + 3);
+            val5 = GET_DATA_BYTE(lines, j + 4);
+            val6 = GET_DATA_BYTE(lines, j + 5);
+            val7 = GET_DATA_BYTE(lines, j + 6);
+            val8 = GET_DATA_BYTE(lines, j + 7);
+            val9 = GET_DATA_BYTE(lines, j + 8);
+            maxval = L_MAX(val1, val2);
+            SET_DATA_BYTE(lined, j, L_MAX(val0, maxval));
+            SET_DATA_BYTE(lined, j + 1, L_MAX(maxval, val3));
+            maxval = L_MAX(val3, val4);
+            SET_DATA_BYTE(lined, j + 2, L_MAX(val2, maxval));
+            SET_DATA_BYTE(lined, j + 3, L_MAX(maxval, val5));
+            maxval = L_MAX(val5, val6);
+            SET_DATA_BYTE(lined, j + 4, L_MAX(val4, maxval));
+            SET_DATA_BYTE(lined, j + 5, L_MAX(maxval, val7));
+            maxval = L_MAX(val7, val8);
+            SET_DATA_BYTE(lined, j + 6, L_MAX(val6, maxval));
+            SET_DATA_BYTE(lined, j + 7, L_MAX(maxval, val9));
+        }
+    }
+    return pixd;
+}
+
+
+/*!
+ *  pixDilateGray3v()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for vertical 1x3 brick Sel;
+ *          also used as the second step for the 3x3 brick Sel.
+ */
+static PIX *
+pixDilateGray3v(PIX  *pixs)
+{
+l_uint32  *datas, *datad, *linesi, *linedi;
+l_int32    w, h, wpl, i, j;
+l_int32    val0, val1, val2, val3, val4, val5, val6, val7, val8, val9, maxval;
+PIX       *pixd;
+
+    PROCNAME("pixDilateGray3v");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+
+    pixd = pixCreateTemplateNoInit(pixs);
+    pixGetDimensions(pixs, &w, &h, NULL);
+    datas = pixGetData(pixs);
+    datad = pixGetData(pixd);
+    wpl = pixGetWpl(pixs);
+    for (j = 0; j < w; j++) {
+        for (i = 1; i < h - 8; i += 8) {
+            linesi = datas + i * wpl;
+            linedi = datad + i * wpl;
+            val0 = GET_DATA_BYTE(linesi - wpl, j);
+            val1 = GET_DATA_BYTE(linesi, j);
+            val2 = GET_DATA_BYTE(linesi + wpl, j);
+            val3 = GET_DATA_BYTE(linesi + 2 * wpl, j);
+            val4 = GET_DATA_BYTE(linesi + 3 * wpl, j);
+            val5 = GET_DATA_BYTE(linesi + 4 * wpl, j);
+            val6 = GET_DATA_BYTE(linesi + 5 * wpl, j);
+            val7 = GET_DATA_BYTE(linesi + 6 * wpl, j);
+            val8 = GET_DATA_BYTE(linesi + 7 * wpl, j);
+            val9 = GET_DATA_BYTE(linesi + 8 * wpl, j);
+            maxval = L_MAX(val1, val2);
+            SET_DATA_BYTE(linedi, j, L_MAX(val0, maxval));
+            SET_DATA_BYTE(linedi + wpl, j, L_MAX(maxval, val3));
+            maxval = L_MAX(val3, val4);
+            SET_DATA_BYTE(linedi + 2 * wpl, j, L_MAX(val2, maxval));
+            SET_DATA_BYTE(linedi + 3 * wpl, j, L_MAX(maxval, val5));
+            maxval = L_MAX(val5, val6);
+            SET_DATA_BYTE(linedi + 4 * wpl, j, L_MAX(val4, maxval));
+            SET_DATA_BYTE(linedi + 5 * wpl, j, L_MAX(maxval, val7));
+            maxval = L_MAX(val7, val8);
+            SET_DATA_BYTE(linedi + 6 * wpl, j, L_MAX(val6, maxval));
+            SET_DATA_BYTE(linedi + 7 * wpl, j, L_MAX(maxval, val9));
+        }
+    }
+    return pixd;
+}
+
+
+/*!
+ *  pixOpenGray3()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *              hsize  (1 or 3)
+ *              vsize  (1 or 3)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for 1x3, 3x1 or 3x3 brick sel (all hits)
+ *      (2) If hsize = vsize = 1, just returns a copy.
+ *      (3) It would be nice not to add a border, but it is required
+ *          to get the same results as for the general case.
+ */
+PIX *
+pixOpenGray3(PIX     *pixs,
+             l_int32  hsize,
+             l_int32  vsize)
+{
+PIX  *pixt, *pixb, *pixbd, *pixd;
+
+    PROCNAME("pixOpenGray3");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pix has colormap", procName, NULL);
+    if ((hsize != 1 && hsize != 3) ||
+        (vsize != 1 && vsize != 3))
+        return (PIX *)ERROR_PTR("invalid size: must be 1 or 3", procName, NULL);
+
+    if (hsize == 1 && vsize == 1)
+        return pixCopy(NULL, pixs);
+
+    pixb = pixAddBorderGeneral(pixs, 4, 8, 2, 8, 255);  /* set to max */
+
+    if (vsize == 1) {
+        pixt = pixErodeGray3h(pixb);
+        pixSetBorderVal(pixt, 4, 8, 2, 8, 0);  /* set to min */
+        pixbd = pixDilateGray3h(pixt);
+        pixDestroy(&pixt);
+    }
+    else if (hsize == 1) {
+        pixt = pixErodeGray3v(pixb);
+        pixSetBorderVal(pixt, 4, 8, 2, 8, 0);
+        pixbd = pixDilateGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+    else {  /* vize == hsize == 3 */
+        pixt = pixErodeGray3h(pixb);
+        pixbd = pixErodeGray3v(pixt);
+        pixDestroy(&pixt);
+        pixSetBorderVal(pixbd, 4, 8, 2, 8, 0);
+        pixt = pixDilateGray3h(pixbd);
+        pixDestroy(&pixbd);
+        pixbd = pixDilateGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+
+    pixd = pixRemoveBorderGeneral(pixbd, 4, 8, 2, 8);
+    pixDestroy(&pixb);
+    pixDestroy(&pixbd);
+    return pixd;
+}
+
+
+/*!
+ *  pixCloseGray3()
+ *
+ *      Input:  pixs (8 bpp, not cmapped)
+ *              hsize  (1 or 3)
+ *              vsize  (1 or 3)
+ *      Return: pixd, or null on error
+ *
+ *  Notes:
+ *      (1) Special case for 1x3, 3x1 or 3x3 brick sel (all hits)
+ *      (2) If hsize = vsize = 1, just returns a copy.
+ */
+PIX *
+pixCloseGray3(PIX     *pixs,
+              l_int32  hsize,
+              l_int32  vsize)
+{
+PIX  *pixt, *pixb, *pixbd, *pixd;
+
+    PROCNAME("pixCloseGray3");
+
+    if (!pixs)
+        return (PIX *)ERROR_PTR("pixs not defined", procName, NULL);
+    if (pixGetDepth(pixs) != 8)
+        return (PIX *)ERROR_PTR("pixs not 8 bpp", procName, NULL);
+    if (pixGetColormap(pixs))
+        return (PIX *)ERROR_PTR("pix has colormap", procName, NULL);
+    if ((hsize != 1 && hsize != 3) ||
+        (vsize != 1 && vsize != 3))
+        return (PIX *)ERROR_PTR("invalid size: must be 1 or 3", procName, NULL);
+
+    if (hsize == 1 && vsize == 1)
+        return pixCopy(NULL, pixs);
+
+    pixb = pixAddBorderGeneral(pixs, 4, 8, 2, 8, 0);  /* set to min */
+
+    if (vsize == 1) {
+        pixt = pixDilateGray3h(pixb);
+        pixSetBorderVal(pixt, 4, 8, 2, 8, 255);  /* set to max */
+        pixbd = pixErodeGray3h(pixt);
+        pixDestroy(&pixt);
+    }
+    else if (hsize == 1) {
+        pixt = pixDilateGray3v(pixb);
+        pixSetBorderVal(pixt, 4, 8, 2, 8, 255);
+        pixbd = pixErodeGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+    else {  /* vize == hsize == 3 */
+        pixt = pixDilateGray3h(pixb);
+        pixbd = pixDilateGray3v(pixt);
+        pixDestroy(&pixt);
+        pixSetBorderVal(pixbd, 4, 8, 2, 8, 255);
+        pixt = pixErodeGray3h(pixbd);
+        pixDestroy(&pixbd);
+        pixbd = pixErodeGray3v(pixt);
+        pixDestroy(&pixt);
+    }
+
+    pixd = pixRemoveBorderGeneral(pixbd, 4, 8, 2, 8);
+    pixDestroy(&pixb);
+    pixDestroy(&pixbd);
+    return pixd;
+}
+
 
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/jpegio.c leptonlib-1.066/src/jpegio.c
--- leptonlib-1.66/src/jpegio.c	2010-03-17 22:38:20.000000000 +0200
+++ leptonlib-1.066/src/jpegio.c	2010-09-08 22:43:57.000000000 +0300
@@ -773,21 +773,37 @@
  *  
  *      Input:  inarray (binary jpeg)
  *              size (of the data array)
- *             &index (<return> location of image metadata)
+ *              &index (<return> location of image metadata)
  *      Return: 0 if OK, 1 on error.  Caller must check this!
  *  
  *  Notes:
- *      (1) The parameters listed here appear to be the only jpeg flags
+ *      (1) The metadata in jpeg files is a mess.  There are markers
+ *          for the chunks that are always preceeded by 0xff.
+ *          It is possible to have 0xff in the binary data that is
+ *          not a marker, and this is always 'escaped' by a following
+ *          0x0 byte.  The two bytes following the marker give the
+ *          chunk size, inclusive of those two bytes.  The jpeg parser
+ *          runs through the file, looking for special markers such
+ *          as 0xc0 and 0xc2 that indicate the beginning of a metadata
+ *          frame that gives the image size, depth, etc.
+ *      (2) The markers listed here appear to be the only ones that
  *          we need to worry about.  It would have been nice to have
- *          avoided the switch with all these parameters, but
+ *          avoided the switch with all these markers, but
  *          unfortunately the parser for the jpeg header is set
- *          to accept any old flag that's not on the approved list!
+ *          to accept any byte marker that's not on the approved list!
  *          So we have to look for a flag that's not on the list
- *          (and is not 0), and then interpret the size of the
- *          data chunk and skip it.  Sometimes such a chunk contains
- *          a thumbnail version of the image, so if we don't skip it,
- *          we will find a pair of bytes such as 0xffc0, followed
- *          by small w and h dimensions. 
+ *          (and is not 0 or followed by 0xff), and then interpret
+ *          the size of the data chunk and skip it.  Why do this?
+ *          Such a chunk may contain a thumbnail version of the image,
+ *          so if we don't skip it, we will find a pair of bytes such
+ *          as 0xffc0 within the chunk, followed by the metadata
+ *          (e.g., w and h dimensions) for the thumbnail.  Not what we want.
+ *      (3) We recently found jpeg files with the sequence 0xffXXff,
+ *          where XX is apparently a random marker not on the 'approved'
+ *          list.  These clearly need to be escaped, because there are
+ *          no chunks of size as great as 0xff00 that can be skipped
+ *          (remember: for chunks that must be skipped, the 2 bytes
+ *          after the marker give the chunk size).
  */
 static l_int32
 locateJpegImageParameters(l_uint8  *inarray,
@@ -804,15 +820,18 @@
     if (!pindex)
         return ERROR_INT("&index not defined", procName, 1);
 
-    index = *pindex;
+    index = 0;  /* start at the beginning of the data */
     while (1) {
         if (getNextJpegMarker(inarray, size, &index))
             break;
         if ((val = inarray[index]) == 0)  /* ignore if "escaped" */
             continue;
+        if (inarray[index + 1] == 0xff)  /* ignore if 'ff' immediately after */
+            continue;
 /*        fprintf(stderr, " marker %x at %o, %d\n", val, index, index); */
         switch(val)
         {
+            /* These are valid metadata start locations */
         case 0xc0:  /* M_SOF0 */
         case 0xc1:  /* M_SOF1 */
         case 0xc2:  /* M_SOF2 */
@@ -828,6 +847,8 @@
             *pindex = index + 1;  /* found it */
             return 0;
 
+            /* Go on -- these are on the 'approved' list and are
+             * not chunks that must be skipped */
         case 0x01:  /* M_TEM */
         case 0xd0:  /* M_RST0 */
         case 0xd1:  /* M_RST1 */
@@ -843,6 +864,7 @@
         case 0xee:  /* M_APP14 */
             break;
 
+            /* Everything else is assumed to be a chunk that must be skipped */
         default:
             skiplength = getTwoByteParameter(inarray, index + 1);
             index += skiplength;
@@ -859,10 +881,10 @@
  *
  *      Input:  array (jpeg data)
  *              size (from current point to the end)
- *             &index (<return> the last position searched.  If it
- *                     is not at the end of the array, we return
- *                     the first byte that is not 0xff, after
- *                     having encountered at least one 0xff.)
+ *              &index (input current and <return> the last position searched.
+ *                      If it is not at the end of the array, we return
+ *                      the first byte that is not 0xff, after
+ *                      having encountered at least one 0xff.)
  *      Return: 0 if a marker is found, 1 if the end of the array is reached
  *      
  *  Notes:
@@ -891,7 +913,7 @@
     if (!pindex)
         return ERROR_INT("&index not defined", procName, 1);
 
-    index = *pindex;
+    index = *pindex;  /* initial location in array */
 
     while (index < size) {  /* skip to 0xff */
        val = array[index++];    
@@ -1111,4 +1133,3 @@
 /* --------------------------------------------*/
 #endif  /* HAVE_LIBJPEG */
 /* --------------------------------------------*/
-
diff -urNad -x '*.png' -x '*.jpg' leptonlib-1.66/src/kernel.c leptonlib-1.066/src/kernel.c
--- leptonlib-1.66/src/kernel.c	2010-01-22 03:16:29.000000000 +0200
+++ leptonlib-1.066/src/kernel.c	2010-09-15 22:36:47.000000000 +0300
@@ -522,7 +522,7 @@
 L_KERNEL *
 kernelReadStream(FILE  *fp)
 {
-l_int32    sy, sx, cy, cx, i, j, ret, version;
+l_int32    sy, sx, cy, cx, i, j, ret, version, ignore;
 L_KERNEL  *kel;
 
     PROCNAME("kernelReadStream");
@@ -546,10 +546,10 @@
 
     for (i = 0; i < sy; i++) {
         for (j = 0; j < sx; j++)
-            fscanf(fp, "%15f", &kel->data[i][j]);
-        fscanf(fp, "\n");
+            ignore = fscanf(fp, "%15f", &kel->data[i][j]);
+        ignore = fscanf(fp, "\n");
     }
-    fscanf(fp, "\n");
+    ignore = fscanf(fp, "\n");
 
     return kel;
 }
